import { WidgetProperty, WidgetSizeEvent, WidgetVisibilityEvent } from "../widgetRuntime/apis/api.interfaces";
import { IWidgetRegistration } from "../widgetRuntime/orchestrator/IWidgetRegistration";
import { OrchestratorEvent, WidgetPropertyInternal } from "../widgetRuntime/orchestrator/orchestrator.types";
import { WidgetSettingsEventInternal, WidgetStatusEventInternal } from "../widgetRuntime/widgetApis/widgetInternalApi.interfaces";
import { IWidgetInstanceInternal } from "../widgetruntime/orchestrator/IWidgetInstanceInternal";
import { WidgetInstanceElement } from "../widgetruntime/widgetInstanceElement/widget-instance";
export declare function getWidgetRegistrationsPromise(): Promise<IWidgetRegistration[]>;
export declare function getWidgetInstancesPromise(): Promise<IWidgetInstanceInternal[]>;
export declare function getFeedsInstancePromise(): Promise<IWidgetInstanceInternal | undefined>;
export declare function getWidgetInstancePromise(index: number): Promise<IWidgetInstanceInternal>;
export declare function addWidgetInstance(widgetRegistration: IWidgetRegistration): Promise<IWidgetInstanceInternal>;
export declare function removeWidgetInstance(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function addWidgetOrchestratorEventListener(orchestratorCallback: (name: OrchestratorEvent, widgetInstance: IWidgetInstanceInternal | null) => void): Promise<void>;
export declare function removeWidgetOrchestratorEventListener(orchestratorCallback: (name: OrchestratorEvent, widgetInstance: IWidgetInstanceInternal | null) => void): Promise<void>;
export declare function getWidgetElementAsync(widgetInstance: IWidgetInstanceInternal): Promise<WidgetInstanceElement>;
export declare function getWidgetStatus(widgetInstance: IWidgetInstanceInternal): Promise<string>;
export declare function addWidgetStatusEventListener(widgetInstance: IWidgetInstanceInternal, statusUpdateCallback: (eventName: WidgetStatusEventInternal) => any): Promise<void>;
export declare function removeWidgetStatusEventListener(widgetInstance: IWidgetInstanceInternal, statusUpdateCallback: (eventName: WidgetStatusEventInternal) => any): Promise<void>;
export declare function addWidgetVisibilityEventListener(widgetInstance: IWidgetInstanceInternal, statusUpdateCallback: (eventName: WidgetVisibilityEvent) => Promise<void>): Promise<void>;
export declare function removeWidgetVisibilityEventListener(widgetInstance: IWidgetInstanceInternal, statusUpdateCallback: (eventName: WidgetVisibilityEvent) => Promise<void>): Promise<void>;
export declare function onTitleInteracted(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function onSettingsInteracted(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function onWidgetPositionUpdated(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function onWidgetVisible(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function onWidgetHidden(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function getWidgetProperty(widgetInstance: IWidgetInstanceInternal, property: WidgetProperty): Promise<string | undefined>;
export declare function setWidgetProperty(widgetInstance: IWidgetInstanceInternal, property: WidgetProperty | WidgetPropertyInternal, value: any): Promise<IWidgetInstanceInternal>;
export declare function addWidgetPropertiesEventListener(widgetInstance: IWidgetInstanceInternal, propertyChangeCallback: (name: WidgetProperty) => any): Promise<void>;
export declare function removeWidgetPropertiesEventListener(widgetInstance: IWidgetInstanceInternal, propertyChangeCallback: (name: WidgetProperty) => any): Promise<void>;
export declare function isConfigurationSupported(widgetInstance: IWidgetInstanceInternal): Promise<boolean>;
export declare function showSettings(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function hideSettings(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function setupShowHideSettingsListeners(widgetInstance: IWidgetInstanceInternal, widgetSettingsEventsCallback: (eventName: WidgetSettingsEventInternal) => any): Promise<void>;
export declare function removeShowHideSettingsListeners(widgetInstance: IWidgetInstanceInternal, widgetSettingsEventsCallback: (eventName: WidgetSettingsEventInternal) => any): Promise<void>;
export declare function updateSize(widgetInstance: IWidgetInstanceInternal, size: string, event: WidgetSizeEvent): Promise<void>;
export declare function onWidgetRemoved(widgetInstance: IWidgetInstanceInternal): Promise<void>;
export declare function isRiverInstance(widgetInstance: IWidgetInstanceInternal): Promise<boolean>;
export declare function onWidgetRemovedFromRiver(widgetInstance: IWidgetInstanceInternal, isHide: boolean): Promise<void>;
